unit ufmquerygrid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, DB, StdCtrls, ExtCtrls,adodb, Buttons,
  IBCustomDataSet, IBQuery, IBTable;

type
  RowNumber = CLASS(TCustomDBGrid);
    tgd=class(tcustomdbgrid)
    private
    protected
    public
      obj:twincontrol;
      fieldname:string;
      fmysender:twincontrol;
      factivefield:tfield;
      freturnfield:tfield;
      procedure DrawDataCell( const Rect: TRect;
        Field: TField; State: TGridDrawState);
      property row;
      property rowheights;
    end;

  Tfmquerygrid = class(TForm)
    gd1: TDBGrid;
    ds1: TDataSource;
    ed1: TEdit;
    Panel1: TPanel;
    SaveDialog1: TSaveDialog;
    bexit: TSpeedButton;
    SpeedButton1: TSpeedButton;
    procedure gd1TitleClick(Column: TColumn);
    procedure gd1DrawDataCell(Sender: TObject; const Rect: TRect;
      Field: TField; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure ed1Exit(Sender: TObject);
    procedure ed1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure gd1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure gd1DblClick(Sender: TObject);
    procedure bexitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    fsw,fso,fsm,fssw:string;
    function getsw:string;
    function getssw:string;
    function getso:string;
    function getsm:string;
    procedure setsw(v:string);
    procedure setssw(v:string);
    procedure setso(v:string);
    procedure setsm(v:string);
  public
    { Public declarations }
    fd:tcolumn;
    procedure dorepaint(dataset:tdataset);
    procedure setsq1(dt:tdataset);
    procedure setsq2(dt:tdataset);
    property psw:string read getsw write setsw;
    property pso:string read getso write setso;
    property psm:string read getsm write setsm;
    property pssw:string read getssw write setssw;
  end;
  procedure showme(dt:tdataset);
  procedure showmen(dt:tdataset);
var
  fmquerygrid: Tfmquerygrid;

implementation

uses UPub;

{$R *.dfm}

procedure showmen(dt:tdataset);
var fm:tfmquerygrid;
    v1:TDataSetNotifyEvent;
begin
    application.CreateForm(Tfmquerygrid,fm);
    fm.FormStyle:=fsmdichild;
    fm.visible:=true;
    fm.Parent:=application.MainForm;
    fm.ds1.DataSet:=dt;
    v1:=dt.AfterScroll;
    if not dt.Active then dt.Active:=true;
    dt.AfterScroll:=fm.dorepaint;
    fm.setsq1(dt);
    //fm.Show;
    dt.AfterScroll:=v1;
end;


procedure showme(dt:tdataset);
var fm:tfmquerygrid;
    v1:TDataSetNotifyEvent;
begin
    application.CreateForm(Tfmquerygrid,fm);
    try
      if not dt.Active then dt.Active:=true;
      fm.ds1.DataSet:=dt;
      v1:=dt.AfterScroll;      
      dt.AfterScroll:=fm.dorepaint;
      fm.setsq1(dt);
      fm.ShowModal;
    finally
      dt.AfterScroll:=v1;
      fm.free;
    end;
end;

procedure Tfmquerygrid.gd1TitleClick(Column: TColumn);
var i:integer;
begin
  fd:=column;
  ed1.Parent:=gd1;
  ed1.visible:=true;
  ed1.text:='';
  ed1.SetFocus ;
end;

{ tgd }

procedure tgd.DrawDataCell(const Rect: TRect; Field: TField;
  State: TGridDrawState);
begin
end;

procedure Tfmquerygrid.gd1DrawDataCell(Sender: TObject; const Rect: TRect;
  Field: TField; State: TGridDrawState);
var i:integer;
begin
  inherited;
  with gd1 do
  begin
    with RowNumber(gd1) do begin
      if (Odd(DataLink.ActiveRecord))
        then begin
        Canvas.Brush.Color := $00FFEBDF;
        canvas.Font.color:=clblack;
        DefaultDrawDataCell(Rect, Field, State);
      end;
      if (state=[gdselected]) then begin
        Canvas.Brush.Color := clblue;
        canvas.Font.color:=clwhite;
        DefaultDrawDataCell(Rect, Field, State);
      end;
    end;
  end;
end;

procedure Tfmquerygrid.dorepaint(dataset:tdataset);
begin
   gd1.Repaint;
end;

procedure Tfmquerygrid.FormCreate(Sender: TObject);
begin
  self.width:=640 * 2 div 3;
  self.height:=480 * 2 div 3;
end;

procedure Tfmquerygrid.ed1Exit(Sender: TObject);
begin
      ed1.visible:=false;
      fd:=nil;
end;

procedure Tfmquerygrid.ed1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i:integer;
    st:tstringlist;
    s:string;
begin
    if key=vk_escape then begin
       self.gd1.SetFocus;
       exit;
    end;

    if key=vk_return then begin
       st:=tstringlist.Create;
       for i:=0 to ds1.DataSet.FieldCount-1 do begin
          st.Add(ds1.DataSet.Fields[i].Displaylabel);
       end;
       for i:=0 to st.Count-1 do begin
           ds1.DataSet.fields[i].DisplayLabel:=st.Strings[i];
       end;
       st.Free;

       case fd.Field.DataType of
         ftstring,ftwidestring:
            s:=fd.fieldname+' like '+quotedstr(ed1.text+'%');
         ftfloat,ftbcd,ftsmallint,ftinteger:
            s:=fd.FieldName+' = '+Ed1.Text;
         ftdatetime:
            s:=fd.FieldName+' = '+quotedstr(Ed1.Text);
       end;
       if trim(ed1.text)='' then begin
          psw:='';
          tibquery(ds1.dataset).SQL.Text:=psm;
          //if pssw <> null then tibquery(ds1.dataset).SQL.Add(pssw);
          if pso <> null then tibquery(ds1.dataset).SQL.Add(pso);          
       end
       else begin
          if trim(psw) <> '' then
             psw:=psw+' and '+s
          else
             psw:=s;
          if pssw='' then begin  //Stwhere
             tibquery(ds1.dataset).SQL.Text:=psm+' where '+psw+pso;
          end
          else begin             //㦳twhere
             tibquery(ds1.dataset).SQL.Text:=psm+pssw+' and '+psw+pso;
          end;
       end;
       ds1.DataSet.open;
       gd1.SetFocus;
    end;
end;

procedure Tfmquerygrid.gd1DrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
begin
    if fd =column then begin
       ed1.Left:=rect.Left;
       ed1.top:=tgd(gd1).RowHeights[0];
       ed1.width:=column.width;
    end;
end;

procedure Tfmquerygrid.gd1DblClick(Sender: TObject);
begin
        self.modalresult:=mrok;
end;

procedure Tfmquerygrid.bexitClick(Sender: TObject);
begin
     close;
end;

function Tfmquerygrid.getsm: string;
begin
     result:=fsm;
end;

function Tfmquerygrid.getso: string;
begin
     result:=fso;
end;

function Tfmquerygrid.getssw: string;
begin
     result:=fssw;
end;

function Tfmquerygrid.getsw: string;
begin
     result:=fsw;
end;

procedure Tfmquerygrid.setsm(v: string);
begin
     if v <> fsm then fsm:=v;
     if rightstr(fsm,1)<> ' ' then
        fsm:=fsm+' ';
end;

procedure Tfmquerygrid.setso(v: string);
begin
     if v <> fso then fso:=v;
     if rightstr(fso,1)<> ' ' then
        fso:=fso+' ';
end;

procedure Tfmquerygrid.setssw(v: string);
begin
     if v <> fssw then fssw:=v;
     if rightstr(fssw,1)<> ' ' then
        fssw:=fssw+' ';
end;

procedure Tfmquerygrid.setsw(v: string);
begin
     if v <> fsw then fsw:=v;
     if rightstr(fsw,1)<> ' ' then
        fsw:=fsw+' ';          
end;

procedure Tfmquerygrid.setsq1(dt:tdataset);
var s:string;
    io,isw,im:integer;
begin
   if dt is tibquery then begin
      s:=uppercase(tibquery(dt).SQL.text);
      io:=pos('ORDER BY',S);
      isw:=pos('WHERE',S);
      IF io >0 then begin
         pso:=copy(s,io-1,length(s));
      end;
      if isw>0 then begin
         if io>0 then 
            pssw:=copy(s,isw-1,io-isw)
         else
            pssw:=copy(s,isw-1,length(s));
         psm:=copy(s,1,isw-1);
      end;
      if isw<=0 then begin
         if io>0 then
            psm:=copy(s,1,io-1)
         else
            psm:=copy(s,1,length(s));
      end;
   end;
end;

procedure Tfmquerygrid.setsq2(dt:tdataset);
begin
   //
end;

procedure Tfmquerygrid.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action:=cafree;
end;

procedure Tfmquerygrid.SpeedButton1Click(Sender: TObject);
var fdname:string;
begin
    if self.SaveDialog1.Execute then begin
       fdname:=savedialog1.FileName;
       upub.DBGrid2Excel(self.gd1,fdname);
    end;
end;

end.
